dnl ----------------------------------------------------------------------------
dnl PSYS_INSERT_LIST(list, item)
dnl ; insert item to list
dnl ----------------------------------------------------------------------------

AC_DEFUN(PSYS_INSERT_LIST, [
    if test "x$$1" = "x"; then
        $1="$2"
    else
        psys_insert_item="$2"
        for i in $psys_insert_item; do
            psys_insert_duplicate="0"
            for j in $$1; do
            if test "x$i" = "x$j"; then
                psys_insert_duplicate="1"
                break
            fi
            done
            if test $psys_insert_duplicate = "0"; then
                $1="$$1 $i"
            fi
        done
    fi
])

dnl ----------------------------------------------------------------------------


dnl ----------------------------------------------------------------------------
dnl PSYS_DELETE_LIST(list, item)
dnl ; delete item from list
dnl ----------------------------------------------------------------------------

AC_DEFUN(PSYS_DELETE_LIST, [
    if test "x$$1" = "x$2"; then
        $1=""
    else
        psys_delete_list=""
        psys_delete_removed=0
        for i in $$1; do
            if test "x$i" != "x$2"; then
                psys_delete_list="$psys_delete_list $i"
            else
                psys_delete_removed=1
            fi
        done
        if test $psys_delete_removed = "1"; then
            $1=$psys_delete_list
        fi
    fi
])

dnl ----------------------------------------------------------------------------


dnl ----------------------------------------------------------------------------
dnl PSYS_CONFIG_NICE(filename)
dnl ; config.nice ./configure ARGUMENT մϴ.
dnl ; ./configure  Ŀ ./config.nice ϸ ˴ϴ.
dnl ----------------------------------------------------------------------------

AC_DEFUN(PSYS_CONFIG_NICE, [
    rm -f $1
    cat >$1<<EOF
#!/bin/sh
#
# generated automatically by configure -*- libpsys -*-

EOF
    for arg in [$]0 "[$]@"; do
        echo '"'"[$]arg"'" \' >> $1
    done
    echo '"[$]@"' >> $1
    chmod +x $1
])

dnl ----------------------------------------------------------------------------


dnl ----------------------------------------------------------------------------
dnl PSYS_SYSTEM_INFO
dnl ; CFLAGS, CPPFLAGS, LIBS Ѵ.
dnl ----------------------------------------------------------------------------    
AC_DEFUN(PSYS_SYSTEM_INFO, [
    case "$host" in
        *mint)
        PSYS_INSERT_LIST(CPPFLAGS, [-DMINT])
        PSYS_INSERT_LIST(LIBS, [-lportlib])
        ;;
        *MPE/iX*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DMPE -D_POSIX_SOURCE -D_SOCKET_SOURCE])
        PSYS_INSERT_LIST(LIBS, [-lsvipc -lcurses])
        PSYS_INSERT_LIST(LDFLAGS, [-Xlinker '"-WL,cap=ia,ba,ph;nmstack=1024000"'])
        ;;
        *-apple-aux3*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DAUX3 -D_POSIX_SOURCE])
        PSYS_INSERT_LIST(LIBS, [-lposix -lbsd])
        PSYS_INSERT_LIST(LDFLAGS, [-s])
        SHELL=/bin/ksh
        ;;
        *-ibm-aix*)
        PSYS_INSERT_LIST(CPPFLAGS, [-U__STR__ -D_THREAD_SAFE])
        case $host in
            *-ibm-aix4.3)
            PSYS_INSERT_LIST(CPPFLAGS, [-D_USE_IRS])
            ;;
            *-ibm-aix5*)
                PSYS_INSERT_LIST(CPPFLAGS, [-D_USE_IRS])
                ;;
                *-ibm-aix4.3.*)
                PSYS_INSERT_LIST(CPPFLAGS, [-D_USE_IRS])
                ;;
            esac
        PSYS_INSERT_LIST(LDFLAGS, [-Wl,-brtl])
        ;;
        *-apollo-*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DAPOLLO])
        ;;
        *-dg-dgux*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DDGUX])
        ;;
        *os2_emx*)
        SHELL=sh
        ;;
        *-hi-hiux)
        PSYS_INSERT_LIST(CPPFLAGS, [-DHIUX])
        ;;
        *-hp-hpux11.*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DHPUX11 -D_REENTRANT -D_XOPEN_SOURCE_EXTENDED])
        ;;
        *-hp-hpux10.*)
        case $host in
            *-hp-hpux10.01)
            PSYS_INSERT_LIST(CPPFLAGS, [-DSELECT_NEEDS_CAST])
            ;;       
        esac
        PSYS_INSERT_LIST(CPPFLAGS, [-D_REENTRANT])
        ;;
        *-hp-hpux*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DHPUX -D_REENTRANT])
        ;;
        *-linux-*)
            case `uname -r` in
            2.* )  PSYS_INSERT_LIST(CPPFLAGS, [-DLINUX=2])
                   ;;
            1.* )  PSYS_INSERT_LIST(CPPFLAGS, [-DLINUX=1])
                   ;;
            * )
                   ;;
            esac
        PSYS_INSERT_LIST(CPPFLAGS, [-D_REENTRANT])
        ;;
        *-GNU*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DHURD])
        ;;
        *-lynx-lynxos)
        PSYS_INSERT_LIST(CPPFLAGS, [-D__NO_INCLUDE_WARN__ -DLYNXOS])
        PSYS_INSERT_LIST(LIBS, [-lbsd])
        ;;
        *486-*-bsdi*)
        PSYS_INSERT_LIST(CFLAGS, [-m486])
        ;;
        *-*-bsdi*)
            case $host in
                *bsdi4.1)
                    PSYS_INSERT_LIST(CFLAGS, [-D_REENTRANT])
                    ;;
            esac
            ;;
        *-openbsd*)
        PSYS_INSERT_LIST(CPPFLAGS, [-D_POSIX_THREADS])
        ;;
        *-netbsd*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DNETBSD])
        ;;
        *-freebsd*)
        case $host in
            *freebsd[2345]*)
            PSYS_INSERT_LIST(CFLAGS, [-funsigned-char])
            ;;
        esac
        PSYS_INSERT_LIST(CPPFLAGS, [-D_REENTRANT -D_THREAD_SAFE])
        ;;
        *-next-nextstep*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DNEXT])
        ;;
        *-next-openstep*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DNEXT])
        ;;
        *-apple-rhapsody*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DRHAPSODY])
        ;;
        *-apple-darwin*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DDARWIN -DSIGPROCMASK_SETS_THREAD_MASK -no-cpp-precomp])
        ;;
        *-dec-osf*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DOSF1])
        ;;
        *-nto-qnx*)
        ;;
        *-qnx)
        PSYS_INSERT_LIST(CPPFLAGS, [-DQNX])
        PSYS_INSERT_LIST(LIBS, [-N128k -lunix])
        ;;
        *-qnx32)
        PSYS_INSERT_LIST(CPPFLAGS, [-DQNX])
        PSYS_INSERT_LIST(CFLAGS, [-mf -3])
        PSYS_INSERT_LIST(LIBS, [-N128k -lunix])
        ;;
        *-isc4*)
        PSYS_INSERT_LIST(CPPFLAGS, [-posix -DISC])
        PSYS_INSERT_LIST(LDFLAGS, [-posix])
        PSYS_INSERT_LIST(LIBS, [-linet])
        ;;
        *-sco3.2v[234]*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSCO -D_REENTRANT])
        if test "$GCC" = "no"; then
            PSYS_INSERT_LIST(CFLAGS, [-Oacgiltz])
        fi
        PSYS_INSERT_LIST(LIBS, [-lPW -lmalloc])
        ;;
        *-sco3.2v5*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSCO5 -D_REENTRANT])
        PSYS_INSERT_LIST(LIBS, [-lprot])
        ;;
        *-sco_sv*|*-SCO_SV*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSCO -D_REENTRANT])
        PSYS_INSERT_LIST(LIBS, [-lPW -lmalloc])
        ;;
        *-solaris2*)
        PLATOSVERS=`echo $host | sed 's/^.*solaris2.//'`
        PSYS_INSERT_LIST(CPPFLAGS, [-DSOLARIS2=$PLATOSVERS -D_POSIX_PTHREAD_SEMANTICS -D_REENTRANT])
        ;;
        *-sunos4*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSUNOS4])
        ;;
        *-unixware1)
        PSYS_INSERT_LIST(CPPFLAGS, [-DUW=100])
        ;;
        *-unixware2)
        PSYS_INSERT_LIST(CPPFLAGS, [-DUW=200])
        PSYS_INSERT_LIST(LIBS, [-lgen])
        ;;
        *-unixware211)
        PSYS_INSERT_LIST(CPPFLAGS, [-DUW=211])
        PSYS_INSERT_LIST(LIBS, [-lgen])
        ;;
        *-unixware212)
        PSYS_INSERT_LIST(CPPFLAGS, [-DUW=212])
        PSYS_INSERT_LIST(LIBS, [-lgen])
        ;;
        *-unixware7)
        PSYS_INSERT_LIST(CPPFLAGS, [-DUW=700])
        PSYS_INSERT_LIST(LIBS, [-lgen])
        ;;
        maxion-*-sysv4*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSVR4])
        PSYS_INSERT_LIST(LIBS, [-lc -lgen])
        ;;
        *-*-powermax*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSVR4])
        PSYS_INSERT_LIST(LIBS, [-lgen])
        ;;
        TPF)
           PSYS_INSERT_LIST(CPPFLAGS, [-DTPF -D_POSIX_SOURCE])
           ;;
        bs2000*-siemens-sysv*)
        CFLAGS=-O
        PSYS_INSERT_LIST(CPPFLAGS, [-DSVR4 -D_XPG_IV -D_KMEMUSER])
        PSYS_INSERT_LIST(LIBS, [-lsocket])
        ;;
        *-siemens-sysv4*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSVR4 -D_XPG_IV -DHAS_DLFCN -DUSE_MMAP_FILES -DUSE_SYSVSEM_SERIALIZED_ACCEPT])
        PSYS_INSERT_LIST(LIBS, [-lc])
        ;;
        pyramid-pyramid-svr4)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSVR4 -DNO_LONG_DOUBLE])
        PSYS_INSERT_LIST(LIBS, [-lc])
        ;;
        DS/90\ 7000-*-sysv4*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DUXPDS])
        ;;
        *-tandem-sysv4*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSVR4])
        ;;
        *-ncr-sysv4)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSVR4 -DMPRAS])
        PSYS_INSERT_LIST(LIBS, [-lc -L/usr/ucblib -lucb])
        ;;
        *-sysv4*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSVR4])
        PSYS_INSERT_LIST(LIBS, [-lc])
        ;;
        88k-encore-sysv4)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSVR4 -DENCORE])
        PSYS_INSERT_LIST(LIBS, [-lPW])
        ;;
        *-uts*)
        PLATOSVERS=`echo $host | sed 's/^.*,//'`
        case $PLATOSVERS in
            2*) PSYS_INSERT_LIST(CPPFLAGS, [-DUTS21])
                PSYS_INSERT_LIST(CFLAGS, [-Xa -eft])
                PSYS_INSERT_LIST(LIBS, [-lbsd -la])
                ;;
            *)  PSYS_INSERT_LIST(CPPFLAGS, [-DSVR4])
                PSYS_INSERT_LIST(CFLAGS, [-Xa])
                ;;
        esac
        ;;
        *-ultrix)
        PSYS_INSERT_LIST(CPPFLAGS, [-DULTRIX])
        SHELL=/bin/sh5
        ;;
        *powerpc-tenon-machten*)
        PSYS_INSERT_LIST(LDFLAGS, [-Xlstack=0x14000 -Xldelcsect])
        ;;
        *-machten*)
        PSYS_INSERT_LIST(LDFLAGS, [-stack 0x14000])
        ;;
        *convex-v11*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DCONVEXOS11])
        CFLAGS=-O1
        PSYS_INSERT_LIST(CFLAGS, [-ext])
        ;;
        i860-intel-osf1)
        PSYS_INSERT_LIST(CPPFLAGS, [-DPARAGON])
        ;;
        *-sequent-ptx2.*.*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSEQUENT=20])
        PSYS_INSERT_LIST(CFLAGS, [-Wc,-pw])
        PSYS_INSERT_LIST(LIBS, [-linet -lc -lseq])
        ;;
        *-sequent-ptx4.0.*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSEQUENT=40])
        PSYS_INSERT_LIST(CFLAGS, [-Wc,-pw])
        PSYS_INSERT_LIST(LIBS, [-linet -lc])
        ;;
        *-sequent-ptx4.[123].*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSEQUENT=41])
        PSYS_INSERT_LIST(CFLAGS, [-Wc,-pw])
        PSYS_INSERT_LIST(LIBS, [-lc])
        ;;
        *-sequent-ptx4.4.*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSEQUENT=44])
        PSYS_INSERT_LIST(CFLAGS, [-Wc,-pw])
        PSYS_INSERT_LIST(LIBS, [-lc])
        ;;
        *-sequent-ptx4.5.*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSEQUENT=45])
        PSYS_INSERT_LIST(CFLAGS, [-Wc,-pw])
        PSYS_INSERT_LIST(LIBS, [-lc])
        ;;
        *-sequent-ptx5.0.*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSEQUENT=50])
        PSYS_INSERT_LIST(CFLAGS, [-Wc,-pw])
        PSYS_INSERT_LIST(LIBS, [-lc])
        ;;
        *NEWS-OS*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DNEWSOS])
        ;;
        *-riscix)
        PSYS_INSERT_LIST(CPPFLAGS, [-DRISCIX])
        CFLAGS=-O
        ;;
        *-irix*)
        PSYS_INSERT_LIST(CPPFLAGS, [-D_POSIX_THREAD_SAFE_FUNCTIONS])
        ;;
        *beos*)
            PSYS_INSERT_LIST(CPPFLAGS, [-DBEOS])
            PLATOSVERS=`uname -r`
            case $PLATOSVERS in
                5.0.4)
                    PSYS_INSERT_LIST(LDFLAGS, [-L/boot/develop/lib/x86 -L/boot/beos/system/lib -lbind -lsocket])
                    PSYS_INSERT_LIST(LIBS, [-lbind -lbe -lroot])
                    PSYS_INSERT_LIST(CPPFLAGS,[-DBONE7])
                    ;;
                5.1)
                    PSYS_INSERT_LIST(LDFLAGS, [-L/boot/develop/lib/x86 -L/boot/beos/system/lib -lbind -lsocket])
                    PSYS_INSERT_LIST(LIBS, [-lbind -lbe -lroot])
                    ;;
        esac
        PSYS_INSERT_LIST(CPPFLAGS, [-DSIGPROCMASK_SETS_THREAD_MASK -DAP_AUTH_DBM_USE_PSYS])
            ;;
        4850-*.*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSVR4 -DMPRAS])
        PSYS_INSERT_LIST(LIBS, [-lc -L/usr/ucblib -lucb])
        ;;
        drs6000*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DSVR4])
        PSYS_INSERT_LIST(LIBS, [-lc -L/usr/ucblib -lucb])
        ;;
        m88k-*-CX/SX|CYBER)
        PSYS_INSERT_LIST(CPPFLAGS, [-D_CX_SX])
        PSYS_INSERT_LIST(CFLAGS, [-Xa])
        ;;
        *-tandem-oss)
        PSYS_INSERT_LIST(CPPFLAGS, [-D_TANDEM_SOURCE -D_XOPEN_SOURCE_EXTENDED=1])
        ;;
        *-ibm-os390)
           PSYS_INSERT_LIST(CPPFLAGS, [-U_NO_PROTO -DPTHREAD_ATTR_SETDETACHSTATE_ARG2_ADDR -DPTHREAD_SETS_ERRNO -DPTHREAD_DETACH_ARG1_ADDR -DSIGPROCMASK_SETS_THREAD_MASK -DTCP_NODELAY=1])
           ;;
        *-ibm-as400)
           ;;
        *cygwin*)
        PSYS_INSERT_LIST(CPPFLAGS, [-DCYGWIN])
        PSYS_INSERT_LIST(LIBS, [-lcrypt])
        ;;
    esac
])

dnl ----------------------------------------------------------------------------


dnl ----------------------------------------------------------------------------
dnl PSYS_DISPLAY_PART(message)
dnl ; ȭ鿡 configure Ǵ  մϴ.
dnl ----------------------------------------------------------------------------

AC_DEFUN(PSYS_DISPLAY_PART, [
    AC_MSG_RESULT()
    AC_MSG_RESULT([${T_MD}$1${T_ME}])
])

dnl ----------------------------------------------------------------------------


dnl ----------------------------------------------------------------------------
dnl PSYS_CHECK_SIZEOF_EXTENDED(size)
dnl ; sizeũ byte ǥ  ִ Type Ѵ.
dnl ----------------------------------------------------------------------------

AC_DEFUN(PSYS_CHECK_SIZEOF_EXTENDED, [
    psys_bits_checking=`expr $1 \* 8`
    AC_MSG_CHECKING([size of p_int${psys_bits_checking}_t])
    case $1 in
        $ac_cv_sizeof_short)
            psys_type_result="short"
            psys_format_result=
            psys_unsigned_format_result=
            psys_constant_result=
            psys_unsigned_constant_result=
            psys_strtoi64_function=
        ;;
        $ac_cv_sizeof_int)
            psys_type_result="int"
            psys_format_result="d"
            psys_unsigned_format_result="u"
            psys_constant_result=
            psys_unsigned_constant_result=
            psys_strtoi64_function=strtoi
        ;;
        $ac_cv_sizeof_long)
            psys_type_result="long"
            psys_format_result="ld"
            psys_unsigned_format_result="lu"
            psys_constant_result="##L"
            psys_unsigned_constant_result="##UL"
            psys_strtoi64_function=strtol
        ;;
        $ac_cv_sizeof_long_long)
            psys_type_result="long long"
            psys_format_result="lld"
            psys_unsigned_format_result="llu"
            psys_constant_result="##LL"
            psys_unsigned_constant_result="##ULL"
            psys_strtoi64_function=strtoll
        ;;
        *)
        AC_MSG_ERROR([
*** libpsys requires a $psys_bits_checking bit types.
*** You might be using GNU C compilers.
        ])
    esac
    AC_MSG_RESULT([$psys_type_result])

    AC_MSG_CHECKING([for p_int${psys_bits_checking}_t])
    if test "x$psys_bits_checking" = "x16"; then
        PSYS_INT16_TYPE=$psys_type_result;
        AC_SUBST([PSYS_INT16_TYPE])
    elif test "x$psys_bits_checking" = "x32"; then
        PSYS_INT32_TYPE=$psys_type_result;
        PSYS_INT32_FORMAT=$psys_format_result;
        PSYS_UINT32_FORMAT=$psys_unsigned_format_result;
        PSYS_INT32_CONSTANT=$psys_constant_result;
        PSYS_UINT32_CONSTANT=$psys_unsigned_constant_result;
        AC_SUBST([PSYS_INT32_TYPE])
        AC_SUBST([PSYS_INT32_FORMAT])
        AC_SUBST([PSYS_UINT32_FORMAT])
        AC_SUBST([PSYS_INT32_CONSTANT])
        AC_SUBST([PSYS_UINT32_CONSTANT])
    elif test "x$psys_bits_checking" = "x64"; then
        PSYS_INT64_TYPE=$psys_type_result;
        PSYS_INT64_FORMAT=$psys_format_result;
        PSYS_UINT64_FORMAT=$psys_unsigned_format_result;
        PSYS_INT64_CONSTANT=$psys_constant_result;
        PSYS_UINT64_CONSTANT=$psys_unsigned_constant_result;
        PSYS_STRTOI64_FUNCTION=$psys_strtoi64_function;
        AC_SUBST([PSYS_INT64_TYPE])
        AC_SUBST([PSYS_INT64_FORMAT])
        AC_SUBST([PSYS_UINT64_FORMAT])
        AC_SUBST([PSYS_INT64_CONSTANT])
        AC_SUBST([PSYS_UINT64_CONSTANT])
        AC_SUBST([PSYS_STRTOI64_FUNCTION])
        if test "x$psys_strtoi64_function" != x; then
            AC_DEFINE(PSYS_HAVE_STRTOI64_FUNCTION, 1, 
                [Whether you have strtoi64])
        fi
    else
        AC_MSG_ERROR([
*** libpsys can't support a $psys_bits_checking bit type.
*** Avalable types are 16, 32, 64 bits.
        ])
    fi
    AC_MSG_RESULT([$1])
])

dnl ----------------------------------------------------------------------------


dnl ----------------------------------------------------------------------------
dnl PSYS_TYPE_SOCKLEN_T
dnl ; socklen_t ü ִ Ȯϰ PSYS_HAVE_SOCKLEN_T Ѵ.
dnl ----------------------------------------------------------------------------

AC_DEFUN(PSYS_TYPE_SOCKLEN_T, [
    AC_CACHE_CHECK(for socklen_t, ac_cv_socklen_t, [
        AC_TRY_COMPILE([
            #include <sys/types.h>
            #include <sys/socket.h>
        ],[
            socklen_t x;
        ],[
            ac_cv_socklen_t=yes
        ],[
            ac_cv_socklen_t=no
        ])
    ])
    if test "$ac_cv_socklen_t" = "yes"; then
        AC_DEFINE(PSYS_HAVE_SOCKLEN_T, 1, [Whether you have socklen_t])
    fi
])

dnl ----------------------------------------------------------------------------
