/*
  +----------------------------------------------------------------------+
  | Portable System Library                                              |
  | Author: Sukchan Lee (acetcom@postech.ac.kr)                          |
  +----------------------------------------------------------------------+

  $Id: memory.h 113 2004-04-06 06:02:40Z acetcom $
*/

#ifndef __PSYS_MEMORY_H__
#define __PSYS_MEMORY_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "psys/common.h"

/**
 * @defgroup memory Memory Pool Functions
 * @ingroup libpsys 
 *
 * @{
 */

#if !HAVE_MEMMOVE
#define memmove(a, b, c)            bcopy(b, a, c)
#endif

typedef struct psys_mem_pool_t      psys_mem_pool_t;

/**
 * Memory Pool Ѵ.
 *
 * @param newpool   Memory Pool
 * @param parent  Memory Pool θ
 *
 * @remark apr_initialize  global_pool ̹ Ǿ ִ. 
 *          parent NULL̸ global_pool θ Ͽ Pool ȴ.
 */
psys_status_t psys_mem_pool_create(
        psys_mem_pool_t **newpool, psys_mem_pool_t *parent);
/**
 * Memory Pool Ѵ.
 *
 * @param pool  Memory Pool
 *
 * @remark  freeԼ Ҹ ʴ´. Allocator ش Ǯ   д.
 */
void psys_mem_pool_destroy(psys_mem_pool_t *pool);

/**
 * Memory Poolκ ޸𸮸 ҴѴ.
 *
 * @param pool Ҵ   Memory Pool
 * @param size Ҵ ޸ ũ
 *
 * @return  Ҵ ޸𸮸 Ѵ.
 */
void *psys_malloc(psys_mem_pool_t *pool, size_t size);

/**
 * Memory Poolκ ޸𸮸 ҴѴ.
 *
 * @param pool Ҵ   Memory Pool
 * @param size Ҵ ޸ ũ
 *
 * @return  Ҵ ޸𸮸 Ѵ.
 *
 * @remark psys_palloc  Ŀ Ҵ ޸𸮸  0 Ѵ.
 */
void *psys_calloc(psys_mem_pool_t *pool, size_t size);

/** @} */

#ifdef __cplusplus
}
#endif

#endif
